// charcode.h cLN^R[hɊւ鏈
// ɂLN^R[h̕ނsR[h́uChUnicodevł
// 肵̂Ȃ̂ŁÃChZbgg悤Ȋł
// ɂ킹ĕς邱ƁB
#ifndef __SGC_CHARCODE__
#define __SGC_CHARCODE__

#include "sgc.h"
#include <wchar.h>


_SGC_BEGIN                              // namespace sgc {

namespace charcode
{
    ////////////////////////////////////////////////////////////
	// 萔
	const size_t POS_INVALID = static_cast<size_t>(-1);


	////////////////////////////////////////////////////////////
	// R[h
	const wchar_t wNUL = L'\0';             // NUL : U+0000

	const wchar_t wTAB       = L'\t';       // TAB       : U+0009
	const wchar_t wSPACE     = L' ' ;       // SPACE     : U+0020
	const wchar_t wWIDESPACE = 0x3000;      // WIDESPACE : U+3000iL'@'j

	const wchar_t wCR  = L'\r';             // LineFeed            : U+000A
	const wchar_t wLF  = L'\n';             // CarriageReturn      : U+000D
	const wchar_t wNEL = 0x0085;            // NextLine            : U+0085
	const wchar_t wVT  = 0x0008;            // Vertical Tabulation : U+0008
	const wchar_t wFF  = 0x000C;            // Form Feed           : U+000C
	const wchar_t wLS  = 0x2028;            // LineSeparator       : U+2028
	const wchar_t wPS  = 0x2029;            // ParagraphSeparator  : U+2029


	// 
	void init(void);


	////////////////////////////////////////////////////////////
	// LN^R[g̕
	typedef enum _categorize_t
	{
		CC_SPACE,                               // zCgXy[X
		CC_ALPHA_UPPER,                         // At@xbg啶
		CC_ALPHA_LOWER,                         // At@xbg
		CC_NUMBER,                              // 
		CC_UNDERSCORE,                          // A_[XRAi_j
		CC_BRACKET,                             // ʁi()[]{}<>j
		CC_SPECIAL,                             // ꕶi#$"'%&~^\+-*/@`;:,.!?|j

		CC_WIDE_ALPHA_UPPER,                    // SpAt@xbg啶
		CC_WIDE_ALPHA_LOWER,                    // SpAt@xbg
		CC_WIDE_NUMBER,                         // Sp
		CC_WIDE_BRACKET,                        // Sp

		// {
		CC_JAPANESE_HIRAGANA,                   // Ђ炪
		CC_JAPANESE_KATAKANA,                   // J^Ji
		CC_JAPANESE_KANJI,                      // 
		CC_JAPANESE_SYMBOL,                     // L

		// nO
		CC_HANGEUL,                             // nO

		// 
		CC_CYRILLIC,                            // L
		CC_ARMENIAN,                            // AjA
		CC_HEBREW,                              // wuC
		CC_ARABIC,                              // ArA
		CC_ARABIC_NUMBER,                       // ArAiigĂ鐔Ƃ͈Ⴄ炵j
		CC_DEVANAGARI,                          // foi[K
		CC_DEVANAGARI_NUMBER,                   // foi[K

		CC_ETC,                                 // ȊO
	} categorize_t;

	categorize_t categorize(const wchar_t wchar);


	////////////////////////////////////////////////////////////
	// sʒǔ

	// sR[h^Cv
	typedef enum _linefeed_t
	{
		CL_DEFAULT,                             // wȂiftHgj
		CL_CR,                                  // Carriage ReturniMacintoshnj
		CL_LF,                                  // Line FeediUnixnj
		CL_CRLF,                                // CR+LFiWindowsnj
		CL_NEL,                                 // NExt Line
		CL_VT,                                  // Vertical Tabulationi^uj
		CL_FF,                                  // Form Feediy[Wj
		CL_LS,                                  // Line Separator
		CL_PS,                                  // Paragraph Separator
	} linefeed_t;

	size_t         find_linefeed(const wchar_t *wstr, const size_t size, linefeed_t &type, size_t &skip);
	bool           set_linefeed_default(const linefeed_t type);
	linefeed_t     set_linefeed_default(void);
	const wchar_t *get_linefeed_string (const linefeed_t type);


	// UTF-8[eB
	namespace utf8
	{
		bool detect(const char *text, const size_t size);
	}
}

_SGC_END                                // }

#endif // __SGC_CHARCODE__
